<template>
  <v-dialog v-model="dialog" max-width="500">
    <v-card>
      <v-card-title class="headline">Add Credits to card</v-card-title>

      <v-card-text>
        <v-form>
          <v-list>
            <find-card v-model="card" :visible="dialog"/>
            <v-currency-field
              label="Current Credits"
              v-bind="currency_config"
              v-model="money"
              disabled
              v-if="this.card"
            />
            <v-currency-field
              label="Total Price"
              v-bind="currency_config"
              v-model="price"
              disabled
            />
            <v-currency-field
              label="Final Credits"
              v-bind="currency_config"
              v-model="finalMoney"
              disabled
              v-if="this.card"
            />
          </v-list>
        </v-form>
      </v-card-text>

      <v-card-actions>
        <v-spacer></v-spacer>

        <v-btn color="red darken-1" flat="flat" @click="dialog = false" :loading="loading">Cancel</v-btn>
        <v-btn
          color="green darken-1"
          flat="flat"
          @click="buyProducts(); dialog = false"
          :loading="loading"
        >Agree</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script>
import gql from "graphql-tag";
import { QrcodeStream } from "vue-qrcode-reader";
import FindCard from "@/components/FindCard";
import { Promise } from "q";

export default {
  components: { QrcodeStream, FindCard },
  props: {
    amounts: { type: Object, required: true }
  },
  data() {
    return {
      card: null,
      products: [],
      dialog: false,
      loading: false,
      price: 0,
      currency_config: {
        decimal: ",",
        thousands: ".",
        prefix: "R$ ",
        precision: 2,
        masked: false,
        allowBlank: false,
        min: Number.MIN_SAFE_INTEGER,
        max: Number.MAX_SAFE_INTEGER
      }
    };
  },
  computed: {
    money() {
      return this.card && this.card.money / 100;
    },
    finalMoney() {
      return this.money && this.money - this.price;
    },
    prices() {
      const prices = {};
      this.products.forEach(product => (prices[product.id] = product.price));
      return prices;
    }
  },
  watch: {
    amounts: {
      deep: true,
      handler() {
        let total = 0;
        Object.keys(this.amounts).forEach(product_id => {
          total += this.prices[product_id] * this.amounts[product_id];
        });
        this.price = total / 100;
      }
    }
  },
  apollo: {
    products: {
      query: gql`
        query {
          products: listProducts {
            id
            price
          }
        }
      `
    }
  },
  methods: {
    open() {
      this.dialog = true;
    },
    async buyProducts() {
      this.loading = true;

      try {
        await Promise.all(
          Object.keys(this.amounts).map(product => {
            const cardNumber = this.card && this.card.number;
            const amount = this.amounts[product];

            this.$apollo.mutate({
              mutation: gql`
                mutation($cardNumber: Int!, $product: ID!, $amount: Int!) {
                  buyProduct(
                    cardNumber: $cardNumber
                    product: $product
                    amount: $amount
                  ) {
                    id
                  }
                }
              `,
              variables: {
                cardNumber,
                product,
                amount
              }
            });
          })
        );
        this.$emit("success");
      } catch (e) {
        console.error(e);
      } finally {
        this.loading = false;
      }
    }
  }
};
</script>
